# -----------------------------------------------------------------------
# Copyright 2023 M. Pêcheux, Les Fées Spéciales

# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at the root of the repo.

# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# -----------------------------------------------------------------------

from fastapi import Depends
from security import oauth2_scheme
from tokens import check_token

from models.extension import Extension
import controllers.extensions as ext


def create_router(app):
    
    # not generated by autorouter, to get custom behaviour with auto-linking / cascading delete

    @app.post('/extensions', tags=['extensions'], response_model=dict)
    async def create_extension(instance_data: Extension, token: str = Depends(oauth2_scheme)) -> dict:
        check_token(token, ['admin'])
        return ext.create_extension(instance_data.dict())
    
    @app.delete('/extensions', tags=['extensions'], response_model=None)
    async def delete_extension(token: str = Depends(oauth2_scheme)) -> None:
        check_token(token, ['admin'])
        return ext.delete_all_extensions()
    
    @app.delete('/extensions/{uid}', tags=['extensions'], response_model=None)
    async def delete_extension(uid: str, token: str = Depends(oauth2_scheme)) -> None:
        check_token(token, ['admin'])
        return ext.delete_extension(uid)
    